<add-export>
  <virtual if={ this.opts.label }>
    <button if={ !this.inList } class=to-add title="Add for export" onclick={ this.addToExport } >
      <icon figure=basket-small />add: { this.opts.label }
    </button>
    <button if={ this.inList } title="Remove from export" onclick={ this.removeFromExport }>
      <icon figure=basket-small />added: { this.opts.label }
    </button>
  </virtual>

  <virtual if={ !this.opts.label }>
    <icon if={ !this.inList } figure=basket onclick={ this.addToExport } title="Add for export" class="to-add" />
    <icon if={ this.inList } figure=basket onclick={ this.removeFromExport } title="Remove from export" />
  </virtual>

  <script>
    this.on('*', () => {
      const organisations = exportList.all().map(l => l.organisation)
      if(this.opts.organisationPk && this.opts.personPk) {
        const contact = exportList.all().find(l => (l.organisation === this.opts.organisationPk && l.person === this.opts.personPk))
        this.inList = Boolean(contact)
      }
      else if(this.opts.organisationPk) this.inList = organisations.includes(this.opts.organisationPk)
      else if(this.opts.personPk) {
        const persons = exportList.all().filter(l => !l.organisation).map(l => l.person)
        this.inList = persons.includes(this.opts.personPk)
      }
    })

    this.addToExport = () => {
      if(this.opts.personPk && this.opts.organisationPk) exportList.add({ person: this.opts.personPk, organisation: this.opts.organisationPk })
      else if(this.opts.personPk) exportList.add({ person: this.opts.personPk })
      else if(this.opts.roles && this.opts.roles.length) exportList.addMany(this.opts.roles)
      else exportList.add({ organisation: this.opts.organisationPk })
      updatePage()
    }

    this.removeFromExport = () => {
      if(this.opts.personPk && this.opts.organisationPk) exportList.remove({ person: this.opts.personPk, organisation: this.opts.organisationPk })
      else if(this.opts.organisationPk) exportList.removeOrganisation(this.opts.organisationPk)
      else if(this.opts.personPk) exportList.remove({ person: this.opts.personPk })
      updatePage()
    }
  </script>

  <style>
    icon {
      width: 1.2rem;
      height: 1.2rem;
      cursor: pointer;
    }

    icon.to-add {
      opacity: .4;
    }

    button {
      display: inline-flex;
    }
    button:not(.to-add) {
      background-color: #e0eaf3;
    }
  </style>
</add-export>
